<?php
ini_set('display_errors', 1);

require_once '../../../resources/base_path_include.php';

require_once $base_path_to_learning_resources  . "includes/connect.php"; // use require for mandatory files
require_once $base_path_to_learning_resources . 'lib/function.php';
require_once $base_path_to_learning_resources . 'lib/validate_api_signature.php';

//valdation file
require_once $base_path_to_learning_resources . 'lib/validate_function.php';
require_once $base_path_to_learning . 'user_management/authenticate.php';
require_once $base_path_to_learning . 'functions/common_functions.php';
//db access function
require_once $base_path_to_learning_resources . 'includes/specific_db_config.php';

//aws image store
require_once $base_path_to_learning_resources . 'lib/bucket_functions/bucket_functions.php';
require_once $base_path_to_learning . "vendor/autoload.php";

require_once $base_path_to_learning_resources . 'includes/aws_bucket_config.php';

use Aws\S3\S3Client;
use Aws\S3\Exception\S3Exception;

$postdata = json_decode(file_get_contents("php://input"), true);
// print_r($postdata);
checkIfNoPhpContentsReceive();

if (
    !isset($postdata['api_signature']) or !checkIfIssetAndNotEmpty($postdata['api_signature']) or
    !isset($postdata['function_type']) or !checkIfIssetAndNotEmpty($postdata['function_type'])  or
     !isset($postdata['jwt_token']) or  !checkIfIssetAndNotEmpty($postdata['jwt_token'])
) {
    errorreturn("All * fields are required.");
}
validateApiSignature($postdata['api_signature']);

$jwttoken = $postdata['jwt_token'];
$jwt_validate = authenticate_jwt($jwttoken);
$userid = $jwt_validate->data->id;
$workspace_id = $jwt_validate->data->workspace_id;
$username = $jwt_validate->data->username;
$role = $jwt_validate->data->role;
$branch_id = $jwt_validate->data->branch_id;
$institution_id = $jwt_validate->data->institution_id;

$specific_db_name = validateUserAccess($conn_rjllearning, $userid, $role, $workspace_id,["principal"], null);
if (!$specific_db_name) {
    errorreturn('Access denied.');
} else {
    $conn_rjllearning_specific = dynamicDbConnection($specific_db_name);
}

require_once $base_path_to_learning . 'user_management/user_versioning.php';

$version = isset($_POST['version']) ? $_POST['version'] : (isset($postdata['version']) ? $postdata['version'] : null);
$updated_time = isset($_POST['updated_time']) ? $_POST['updated_time'] : (isset($postdata['updated_time']) ? $postdata['updated_time'] : null);

$response = user_data_refresh($conn_rjllearning, $conn_rjllearning_specific,$version, $updated_time, $userid, $institution_id);

function getLesson($conn_rjllearning_specific, $institution_id, $search_string, $branch_id, $subject_id, $class_id, $section_id, $from_date, $to_date, $publish_date, $limit, $offset)
{
    $sql_count = "SELECT  count(*) as total_rows FROM  lessons  where institution_id =?";
    $array_params = [$institution_id];
    
    if ($branch_id == 'all') {
        $sql_count .= "";
    } else if ($branch_id !=  null  && $branch_id != 'all') {
        $sql_count .= " AND (branch_id = ?  or branch_id = 'all')";
        $array_params[] = $branch_id;
    }

    if ($class_id == 'all') {
        $sql_count .= "";
    } else if ($class_id !=  null  && $class_id != 'all') {
        $sql_count .= " AND class_id = ? ";
        $array_params[] = $class_id;
    }

    if ($section_id == 'all') {
        $section_id .= "";
    } else if ($section_id !=  null  && $section_id != 'all') {
        $sql_count .= " AND (section_id LIKE ? or section_id  = 'all') ";
        $array_params[] = '%"' . $section_id . '"%';
    }

    if ($subject_id == 'all') {
        $sql_count .= "";
    } else if ($subject_id !=  null  && $subject_id != 'all') {
        $sql_count .= " AND subject_id = ? ";
        $array_params[] = $subject_id;
    }

    if ($search_string != null) {
        $sql_count .= " AND (lesson_name LIKE ? OR author LIKE ? OR description LIKE ?)";
        $array_params[] = '%' . $search_string . '%'; // Append to $array_params
        $array_params[] = '%' . $search_string . '%';
        $array_params[] = '%' . $search_string . '%';
    }

    if ($publish_date != null) {
        $sql_count .= " AND publish_date = ?";
        $array_params[] = $publish_date;
    }

    // Add date range condition
    if ($from_date != null && $to_date != null) {
        $sql_count .= " AND date_created BETWEEN ? AND ?";
        $array_params[] = $from_date;
        $array_params[] = $to_date;
    }
    $stmt = $conn_rjllearning_specific->prepare($sql_count);
    $stmt->execute($array_params);
    $result_total = $stmt->fetchAll();
    $totalrows = $result_total[0]['total_rows'];

    if ($limit == 'all') {

        $sql_lessons = "SELECT * FROM  lessons  where institution_id =? ";
        $array_params = [$institution_id];
        if ($branch_id == 'all') {
            $sql_lessons .= "";
        } else if ($branch_id !=  null  && $branch_id != 'all') {
            $sql_lessons .= " AND (branch_id = ?  or branch_id = 'all') ";
            $array_params[] = $branch_id;
        }

        if ($class_id == 'all') {
            $sql_lessons .= "";
        } else if ($class_id !=  null  && $class_id != 'all') {
            $sql_lessons .= " AND class_id = ? ";
            $array_params[] = $class_id;
        }

        if ($section_id == 'all') {
            $section_id .= "";
        } else if ($section_id !=  null  && $section_id != 'all') {
            $sql_lessons .= " AND (section_id LIKE ? or section_id = 'all') ";
            $array_params[] = '%"' . $section_id . '"%';
        }

        if ($subject_id == 'all') {
            $sql_lessons .= "";
        } else if ($subject_id !=  null  && $subject_id != 'all') {
            $sql_lessons .= " AND subject_id = ? ";
            $array_params[] = $subject_id;
        }

        if ($search_string != null) {
            $sql_lessons .= " AND (lesson_name LIKE ? OR author LIKE ? OR description LIKE ?)";
            $array_params[] = '%' . $search_string . '%'; // Append to $array_params
            $array_params[] = '%' . $search_string . '%';
            $array_params[] = '%' . $search_string . '%';
        }

        if ($publish_date != null) {
            $sql_lessons .= " AND publish_date = ?";
            $array_params[] = $publish_date;
        }

        // Add date range condition
        if ($from_date != null && $to_date != null) {
            $sql_lessons .= " AND date_created BETWEEN ? AND ?";
            $array_params[] = $from_date;
            $array_params[] = $to_date;
        }


        $sql_lessons .=  "order by date_created desc, time_created desc";
    } else {
        $sql_lessons = "SELECT * FROM lessons WHERE institution_id = ?";
        $array_params = [$institution_id];

        if ($branch_id == 'all') {
            $sql_lessons .= "";
        } else if ($branch_id !=  null  && $branch_id != 'all') {
            $sql_lessons .= " AND (branch_id = ?  or branch_id = 'all') ";
            $array_params[] = $branch_id;
        }

        if ($class_id == 'all') {
            $sql_lessons .= "";
        } else if ($class_id !=  null  && $class_id != 'all') {
            $sql_lessons .= " AND class_id = ? ";
            $array_params[] = $class_id;
        }

        if ($section_id == 'all') {
            $section_id .= "";
        } else if ($section_id !=  null  && $section_id != 'all') {
            $sql_lessons .= " AND (section_id LIKE ? or section_id = 'all') ";
            $array_params[] = '%"' . $section_id . '"%';
        }

        if ($subject_id == 'all') {
            $sql_lessons .= "";
        } else if ($subject_id !=  null  && $subject_id != 'all') {
            $sql_lessons .= " AND subject_id = ? ";
            $array_params[] = $subject_id;
        }

        if ($search_string != null) {
            $sql_lessons .= " AND (lesson_name LIKE ? OR author LIKE ? OR description LIKE ?)";
            $array_params[] = '%' . $search_string . '%'; // Append to $array_params
            $array_params[] = '%' . $search_string . '%';
            $array_params[] = '%' . $search_string . '%';
        }

        if ($publish_date != null) {
            $sql_lessons .= " AND publish_date = ?";
            $array_params[] = $publish_date;
        }

        // Add date range condition
        if ($from_date != null && $to_date != null) {
            $sql_lessons .= " AND date_created BETWEEN ? AND ?";
            $array_params[] = $from_date;
            $array_params[] = $to_date;
        }
        $sql_lessons .= " order by date_created desc, time_created desc ";
        $sql_lessons .= "LIMIT " . $offset . " ," . $limit . "";
    }
    // print_r($sql_lessons);die();
    $stmt = $conn_rjllearning_specific->prepare($sql_lessons);
    $stmt->execute($array_params);
    $session_rows = $stmt->fetchAll();


    $array_return = [];

    foreach ($session_rows as $rows) {

        if ($rows['audio_attachment'] != null and !is_array($rows['audio_attachment'])) {
            $data_attachment = json_decode($rows['audio_attachment'], true);
            $filePath = $data_attachment['filepath'];
            $originalName = $data_attachment['original_name'];
            $audio_attachment = displayFileFromS3($GLOBALS['s3_learning_bucket'], $GLOBALS['learning_bucketName'], $filePath);
            //$final_array_audio   = array("filepath" => $aws_attachment, "original_name" => $originalName);
        } else {
            $audio_attachment =  null;
        }

        if ($rows['primary_attachment'] != null and !is_array($rows['primary_attachment'])) {
            $data_attachment = json_decode($rows['primary_attachment'], true);
            $filePath = $data_attachment['filepath'];
            $originalName = $data_attachment['original_name'];
            $primary_attachment = displayFileFromS3($GLOBALS['s3_learning_bucket'], $GLOBALS['learning_bucketName'], $filePath);
            //$final_array_attachment   = array("filepath" => $aws_attachment, "original_name" => $originalName);
        } else {
            $primary_attachment =  null;
        }

        if ($rows['cover_image'] != null and !is_array($rows['cover_image'])) {
            $data_attachment = json_decode($rows['cover_image'], true);
            $filePath = $data_attachment['filepath'];
            $originalName = $data_attachment['original_name'];
            $cover_attachment = displayFileFromS3($GLOBALS['s3_learning_bucket'], $GLOBALS['learning_bucketName'], $filePath);
            //$final_cover_image   = array("filepath" => $aws_attachment, "original_name" => $originalName);
        } else {
            $cover_attachment =  null;
        }

        $branch_id = $rows['branch_id'];

        // $branch = []; // Initialize branches array

        // if ($branch_id == 'all') {

        //     $branch[] = array('branch_id' => $branch_id, 'name' => ucwords($branch_id));
        // } else {
        //     // $imploded_branchids = implode(',', $branch_id); // Convert array to comma-separated string
        //     // print_R($imploded_branchids);
        //     $sql = "SELECT * FROM branch WHERE institution_id = ? AND id IN ($branch_id) ";
        //     $array_params = [$institution_id]; // Add institution_id to parameters
        //     $stmt = $conn_rjllearning_specific->prepare($sql);
        //     $stmt->execute($array_params);
        //     $section_rows = $stmt->fetchAll();

        //     foreach ($section_rows as $section_data) {
        //         $branch[] = array('branch_id' => $section_data['id'], 'name' => $section_data['name']);
        //     }
        // }

        $section_id = $rows['section_id'];
        // $section_info = [];
        // if ($section_id == 'all') {

        //     $section_info[] = array('section_id' => $section_id, 'section_name' => ucwords($section_id));
        // } else {
        //     // $imploded_branchids = implode(',', $branch_id); // Convert array to comma-separated string
        //     // print_R($imploded_branchids);
        //     $sql = "SELECT * FROM section_info WHERE institution_id = ? AND id IN ($section_id) ";
        //     $array_params = [$institution_id]; // Add institution_id to parameters
        //     $stmt = $conn_rjllearning_specific->prepare($sql);
        //     $stmt->execute($array_params);
        //     $section_rows = $stmt->fetchAll();

        //     foreach ($section_rows as $section_data) {
        //         $section_info[] = array('section_id' => $section_data['id'], 'section_name' => $section_data['section_name']);
        //     }
        // }
        $section_info = array();
        $section_id = json_decode($rows['section_id'], true);
        // print_r($section_id);
        // Check if JSON decoding failed or if it's a plain string
        if ($rows['section_id'] === 'all') {
            $section_info[] = array('section_id' => 'all', 'section_name' => ucwords('all'));
        } elseif (is_array($section_id)) {
            // JSON decoding succeeded, and it's an array
            // $placeholders = implode(',', array_fill(0, count($section_id), '?')); // Prepare placeholders for `IN`
            //   $imploded_branchids = implode(',', $section_id);
            // Create placeholders for `id IN` clause
            $placeholders = implode(',', array_fill(0, count($section_id), '?'));

            $sql = "SELECT * FROM section_info 
            WHERE institution_id = ? 
            AND (id IN ($placeholders) OR id = 'all') 
            AND (branch_id LIKE ? OR branch_id = 'all')";

            // Merge institution_id, section_id array, and branch_id into params
            $array_params = array_merge([$institution_id], $section_id, ['%' .  $rows['branch_id'] . '%']);
            $stmt = $conn_rjllearning_specific->prepare($sql);
            $stmt->execute($array_params);
            $section_rows = $stmt->fetchAll();

            // Process fetched rows
            foreach ($section_rows as $section_data) {
                $section_info[] = array('section_id' => $section_data['id'], 'section_name' => $section_data['section_name']);
            }
        }

        $class_info = getClass($conn_rjllearning_specific, $institution_id, $rows['class_id']);
        $subject_info = getSubject($conn_rjllearning_specific, $institution_id, $rows['subject_id']);
        if ($rows['branch_id'] == 'all') {
            $branch[] = array('branch_id' => 'all', 'name' => ucwords('all'));
        } else {
            $branch = getBranchInfo($conn_rjllearning_specific, $institution_id, $rows['branch_id']);
        }
        $lesson_category_id = $rows['lesson_category_id'];
        $sql_category = "SELECT id,topic_name FROM lesson_categories WHERE id = ? AND institution_id = ?";
        $array_params = [$lesson_category_id, $institution_id];
        $stmtCategory = $conn_rjllearning_specific->prepare($sql_category);
        $stmtCategory->execute($array_params);
        $ResultLesson = $stmtCategory->fetchAll();

        if (count($ResultLesson) != 1) {

            errorreturn("Lesson category not exists.");
        }

        foreach ($ResultLesson as $CategoryRows) {
            $lesson_categories =  array("lesson_category_id" => $CategoryRows['id'], "topic_name" => $CategoryRows['topic_name']);
        }

        $array_return[] = array(
            'lesson_id' => $rows['id'],
            'branch_id' => $branch,
            'class_info' => $class_info,
            'section_id' => $section_info,
            'subject_info' => $subject_info,
            'publish_date' => $rows['publish_date'],
            'publish_time' => $rows['publish_time'],
            'terminate_date' => $rows['terminate_date'],
            'termination_time' => $rows['termination_time'],
            'lesson_category_id' => $lesson_categories,
            'lesson_number' => $rows['lesson_number'],
            'lesson_name' => $rows['lesson_name'],
            'author' => $rows['author'],
            'description' => $rows['description'],
            'type' => $rows['type'],
            'primary_attachment' => $primary_attachment,
            'cover_image' => $cover_attachment,
            'audio_attachment' => $audio_attachment,
            'link' => $rows['link']
        );
    }

    if (count($session_rows) < 50) {

        return array('total_rows' => $totalrows, 'lesson_info' => $array_return, 'maxreach' => 1);
    } else {
        return array('total_rows' => $totalrows, 'lesson_info' => $array_return, 'maxreach' => 0);
    }
}

if ($postdata['function_type'] == "fetch_lesson") {
    
    $check_academic_confirmation = CheckAcademicSession($conn_rjllearning_specific, $institution_id);
    if ($check_academic_confirmation != true) {
        errorreturn("Access denied. Academic session not active.");
    }
    
    if (isset($postdata['subject_id']) and !empty($postdata['subject_id']) and trim($postdata['subject_id'])) {
        $subject_id = trim($postdata['subject_id']);
    } else {
        $subject_id = null;
    }
    if (isset($postdata['class_id']) and !empty($postdata['class_id']) and trim($postdata['class_id'])) {
        $class_id = trim($postdata['class_id']);
    } else {
        $class_id = null;
    }

    if (isset($postdata['section_id']) and !empty($postdata['section_id']) and trim($postdata['section_id'])) {
        $section_id = trim($postdata['section_id']);
    } else {
        $section_id = null;
    }

    if (isset($postdata['search_string']) and !empty($postdata['search_string'])) {
        $search_string = trim($postdata['search_string']);
    } else {
        $search_string = null;
    }


    if (isset($postdata['class_id']) and !empty($postdata['class_id']) and trim($postdata['class_id'])) {
        $class_id = trim($postdata['class_id']);
    } else {
        $class_id = "all";
    }
    if (isset($postdata['from_date']) and !empty($postdata['from_date'])) {
        $from_date = trim($postdata['from_date']);
    } else {
        $from_date = null;
    }
    if (isset($postdata['to_date']) and !empty($postdata['to_date'])) {
        $to_date = trim($postdata['to_date']);
    } else {
        $to_date = null;
    }

    if (isset($postdata['publish_date']) and !empty($postdata['publish_date'])) {
        $publish_date = trim($postdata['publish_date']);
    } else {
        $publish_date = null;
    }

    if ($from_date > $to_date) {
        errorreturn('Invalid Date format');
    }
    $limit = $postdata['limit'];

    $page = (isset($postdata['page']) and isNumeric($postdata['page'])) ? (int)$postdata['page'] : 1;

    if ($limit != 'all') {
        $offset = ($page - 1) * $limit;
        $success['data'] = getLesson($conn_rjllearning_specific, $institution_id, $search_string, $branch_id, $subject_id, $class_id,$section_id, $from_date, $to_date, $publish_date, $limit, $offset);
        successreturn($success);
    } else {
        $success['data'] = getLesson($conn_rjllearning_specific, $institution_id, $search_string, $branch_id, $subject_id, $class_id,$section_id, $from_date, $to_date, $limit, null);
        successreturn($successgetLesson);
    }
}
